#include "Types.r"
#include "SysTypes.r"

resource 'MENU' (128, preload) {
	128,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About Simple", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (129, preload) {
	129,
	textMenuProc,
	0xE00,
	enabled,
	"File",
	{	/* array: 10 elements */
		/* [1] */
		"New", noIcon, "N", noMark, plain,
		/* [2] */
		"Open", noIcon, "O", noMark, plain,
		/* [3] */
		"Close", noIcon, "W", noMark, plain,
		/* [4] */
		"Save", noIcon, "S", noMark, plain,
		/* [5] */
		"Save As...", noIcon, noKey, noMark, plain,
		/* [6] */
		"-", noIcon, noKey, noMark, plain,
		/* [7] */
		"Page Setup...", noIcon, noKey, noMark, plain,
		/* [8] */
		"Print...", noIcon, "P", noMark, plain,
		/* [9] */
		"-", noIcon, noKey, noMark, plain,
		/* [10] */
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (130, preload) {
	130,
	textMenuProc,
	0x3400,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Cut", noIcon, "X", noMark, plain,
		/* [4] */
		"Copy", noIcon, "C", noMark, plain,
		/* [5] */
		"Paste", noIcon, "V", noMark, plain,
		/* [6] */
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (131) {
	131,
	textMenuProc,
	0x7FFFFFDF,
	enabled,
	"Test",
	{	/* array: 2 elements */
		/* [1] */
		"Test Folder Get with Gray", noIcon, noKey, noMark, plain,
		/* [2] */
		"Test Folder Get without Gray", noIcon, noKey, noMark, plain
	}
};

resource 'DITL' (128, purgeable) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{164, 115, 184, 185},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{5, 10, 43, 290},
		StaticText {
			disabled,
			"A simple program for demonstrating ideas."
		},
		/* [3] */
		{77, 1, 155, 299},
		StaticText {
			disabled,
			"Developer Technical Support\nCopyright   1991-1993 Apple Computer Inc."
			"\nWritten by C.K. Haun (<TR>).  \nThink version by Brian Bechtel"
		},
		/* [4] */
		{53, 82, 71, 227},
		StaticText {
			disabled,
			"version 1.0d1"
		}
	}
};

resource 'DITL' (129, purgeable) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{170, 90, 190, 148},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 40, 62, 204},
		StaticText {
			disabled,
			"This is where you would put your help information"
		}
	}
};

resource 'DITL' (130, purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{80, 100, 100, 158},
		Button {
			enabled,
			"Exit"
		},
		/* [2] */
		{10, 80, 27, 237},
		StaticText {
			disabled,
			"Bad System Version!"
		},
		/* [3] */
		{50, 25, 66, 232},
		StaticText {
			disabled,
			"Requires System 7 or greater."
		}
	}
};

resource 'DITL' (300) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{160, 90, 180, 148},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{40, 30, 134, 224},
		EditText {
			enabled,
			"Text to edit"
		}
	}
};

resource 'ALRT' (128, purgeable) {
	{40, 40, 229, 363},
	128,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'ALRT' (130, purgeable) {
	{40, 40, 149, 296},
	130,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'MBAR' (128) {
	{	/* array MenuArray: 4 elements */
		/* [1] */
		128,
		/* [2] */
		129,
		/* [3] */
		130,
		/* [4] */
		131
	}
};

resource 'WIND' (128, purgeable) {
	{40, 40, 310, 572},
	zoomDocProc,
	visible,
	goAway,
	0x0,
	"Simple"
};

resource 'STR ' (128) {
	"Simple Help..."
};

resource 'DLOG' (129, "Sample Help Dialog", purgeable) {
	{34, 40, 234, 280},
	dBoxProc,
	visible,
	goAway,
	0x0,
	129,
	""
};

resource 'dctb' (300) {
	{	/* array ColorSpec: 5 elements */
		/* [1] */
		wContentColor, 65535, 52428, 13107,
		/* [2] */
		wFrameColor, 13107, 13107, 39321,
		/* [3] */
		wTextColor, 0, 0, 0,
		/* [4] */
		wHiliteColor, 39321, 52428, 65535,
		/* [5] */
		wTitleBarColor, 26214, 65535, 52428
	}
};

data 'ictb' (300, purgeable) {
	$"0000 0000 2008 0008 0000 0000 0000 0000 0000 0000 FFFF FFFF FFFF 0000"                              /* .... ....................... */
};

resource 'ics8' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 00F6 0000 0000 0000 0000"
	$"0000 0000 0000 F6F6 F600 0000 0000 0000 0000 0000 00F6 F6F6 F6F6 0000 0000 0000"
	$"0000 0000 F6F6 F6F6 F6F6 F600 0000 0000 0000 00F6 F6F6 F6F6 F6F6 F6F6 0000 0000"
	$"0000 F6F6 F6F6 F6F6 F6F6 F6F6 F600 0000 00F6 F6F6 F6F6 F6F6 0F0F 0FF6 F6F6 0000"
	$"F9F9 F6F6 F6F6 F665 FF65 0F0F F6F6 F600 00F9 F9F6 F6FF FFFF FFFF FFFF 0FF6 FB00"
	$"0000 F9F9 F6F6 F965 650F 0F0F 0F0F FB00 0000 00F9 F9F6 F9F9 6565 6565 65FB FF00"
	$"0000 0000 F9F9 F6F9 F9F9 F9F9 65FF FF00 0000 0000 00F9 F9F6 F9FA 0000 00FF FF00"
	$"0000 0000 0000 F9F9 F900 0000 0000 0000 0000 0000 0000 00F9"
};

resource 'ics4' (128, purgeable) {
	$"0000 0000 0000 0000 0000 000C 0000 0000 0000 00CC C000 0000 0000 0CCC CC00 0000"
	$"0000 CCCC CCC0 0000 000C CCCC CCCC 0000 00CC CCCC CCCC C000 0CCC CCCC 222C CC00"
	$"DDCC CCCA FA22 CCC0 0DDC CFFF FFFF 2CE0 00DD CCDA A222 22E0 000D DCDD AAAA AEF0"
	$"0000 DDCD DDDD AFF0 0000 0DDC DD00 0FF0 0000 00DD D000 0000 0000 000D"
};

resource 'ics#' (128, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0100 0280 0440 0820 1010 2008 4064 8092 414E 26F6 1106 08FE 0446 0280 01",
		/* [2] */
		$"0000 0100 0380 07C0 0FE0 1FF0 3FF8 7FFC FFFE 7FFE 3FFE 1FFE 0FFE 07C6 0380 01"
	}
};

resource 'ICN#' (128, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0001 0000 0002 8000 0004 4000 0008 2000 0010 1000 0020 0800 0040 0400 0080 0200"
		$"0100 0100 0200 0080 0400 0040 0800 0020 1000 0010 2000 0008 4000 3F04 8000 4082"
		$"4000 8041 2001 3022 1001 C814 080E 7F8F 0402 3007 0201 0007 0100 8007 0080 6007"
		$"0040 1FE7 0020 021F 0010 0407 0008 0800 0004 1000 0002 2000 0001 4000 0000 80",
		/* [2] */
		$"0001 0000 0003 8000 0007 C000 000F E000 001F F000 003F F800 007F FC00 00FF FE00"
		$"01FF FF00 03FF FF80 07FF FFC0 0FFF FFE0 1FFF FFF0 3FFF FFF8 7FFF FFFC FFFF FFFE"
		$"7FFF FFFF 3FFF FFFE 1FFF FFFC 0FFF FFFF 07FF FFFF 03FF FFFF 01FF FFFF 00FF FFFF"
		$"007F FFFF 003F FE1F 001F FC07 000F F800 0007 F000 0003 E000 0001 C000 0000 80"
	}
};

resource 'icl8' (128) {
	$"0000 0000 0000 0000 0000 0000 0000 00F6 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 F6F6 F600 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00F6 F6F6 F6F6 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 F6F6 F6F6 F6F6 F600 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00F6 F6F6 F6F6 F6F6 F6F6 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 F6F6 F6F6 F6F6 F6F6 F6F6 F600 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 00F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F600 0000 0000 0000 0000"
	$"0000 0000 0000 00F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 0000 0000 0000 0000"
	$"0000 0000 0000 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F600 0000 0000 0000"
	$"0000 0000 00F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 0000 0000 0000"
	$"0000 0000 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F600 0000 0000"
	$"0000 00F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 0000 0000"
	$"0000 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F600 0000"
	$"00F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 080F 080F 0F0F F6F6 F6F6 F6F6 F6F6 0000"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F608 0F0F 0F08 0F08 0FF6 F6F6 F6F6 F6F6 F600"
	$"F9F9 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 080F 6565 160F 0808 080F F6F6 F6F6 F6F6 F600"
	$"00F9 F9F6 F6F6 F6F6 F6F6 F6F6 F608 0F65 FFFF 6516 0F08 0808 0FF6 F6F6 F6F6 F900"
	$"0000 F9F9 F6F6 F6F6 F6F6 F6F6 F665 65FF 6565 FF65 160F 0808 080F F6F6 F6F9 0000"
	$"0000 00F9 F9F6 F6F6 F6F6 F6FF FF08 08FF FFFF FFFF FFFF FF08 0808 0FF6 FBFB FBFB"
	$"0000 0000 F9F9 F6F6 F6F6 F6F6 6565 160F 6565 0F0F 0808 0808 0808 0800 FAFA FBFB"
	$"0000 0000 00F9 F9F6 F6F6 F6F6 F965 6516 0F0F 0808 0F0F 0F0F 0F0F 0F00 FAFA FBFB"
	$"0000 0000 0000 F9F9 F6F6 F6F6 F6F9 6565 6516 1616 160F 1616 1616 65F6 FBFB FDFF"
	$"0000 0000 0000 00F9 F9F6 F6F6 F6F6 F965 6565 6565 6565 6565 6565 65F8 FBFB FFFF"
	$"0000 0000 0000 0000 F9F9 F6F6 F6F6 F9F9 F965 6565 6565 6565 6565 65F8 FDFD FFFF"
	$"0000 0000 0000 0000 00F9 F9F6 F6F6 F6F9 F9F9 F9F9 F9F9 F9F9 0065 65FB FFFF FFFF"
	$"0000 0000 0000 0000 0000 F9F9 F6F6 F6F6 F6F9 F9F9 F9F9 F900 0000 00FB FFFF FFFF"
	$"0000 0000 0000 0000 0000 00F9 F9F6 F6F6 F6F6 FAF9 F9F9 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 F9F9 F6F6 F6F6 F9F9 F900 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00F9 F9F6 F6F9 F9F9 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 F9F9 F9F9 F900 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00F9 F9F9"
};

resource 'icl4' (128) {
	$"0000 0000 0000 000C 0000 0000 0000 0000 0000 0000 0000 00CC C000 0000 0000 0000"
	$"0000 0000 0000 0CCC CC00 0000 0000 0000 0000 0000 0000 CCCC CCC0 0000 0000 0000"
	$"0000 0000 000C CCCC CCCC 0000 0000 0000 0000 0000 00CC CCCC CCCC C000 0000 0000"
	$"0000 0000 0CCC CCCC CCCC CC00 0000 0000 0000 0000 CCCC CCCC CCCC CCC0 0000 0000"
	$"0000 000C CCCC CCCC CCCC CCCC 0000 0000 0000 00CC CCCC CCCC CCCC CCCC C000 0000"
	$"0000 0CCC CCCC CCCC CCCC CCCC CC00 0000 0000 CCCC CCCC CCCC CCCC CCCC CCC0 0000"
	$"000C CCCC CCCC CCCC CCCC CCCC CCCC 0000 00CC CCCC CCCC CCCC CCCC CCCC CCCC C000"
	$"0CCC CCCC CCCC CCCC C2C2 22CC CCCC CC00 CCCC CCCC CCCC CCCC 222C 222C CCCC CCC0"
	$"DDCC CCCC CCCC CCC2 AA22 2222 CCCC CCC0 0DDC CCCC CCCC CC2A FFA2 2222 2CCC CCD0"
	$"00DD CCCC CCCC CAAF AAFA 2222 22CC CD00 000D DCCC CCCF FCCF FFFF FFF2 222C EEEE"
	$"0000 DDCC CCCC AA22 AA22 2222 2220 DDEE 0000 0DDC CCCC DAA2 2222 2222 2220 DDEE"
	$"0000 00DD CCCC CDAA A222 2222 22AC EEAF 0000 000D DCCC CCDA AAAA AAAA AAAC EEFF"
	$"0000 0000 DDCC CCDD DAAA AAAA AAAC AAFF 0000 0000 0DDC CCCD DDDD DDDD 0AAE FFFF"
	$"0000 0000 00DD CCCC CDDD DDD0 000E FFFF 0000 0000 000D DCCC CCDD DD00 0000 0000"
	$"0000 0000 0000 DDCC CCDD D000 0000 0000 0000 0000 0000 0DDC CDDD 0000 0000 0000"
	$"0000 0000 0000 00DD DDD0 0000 0000 0000 0000 0000 0000 000D DD"
};

resource 'BNDL' (128) {
	'SFGP',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 0
		}
	}
};

type 'SFGP' as 'STR ';

resource 'SFGP' (0, "Owner resource") {
	"This should have a real icon instead."
};

data 'FREF' (128) {
	$"4150 504C 0000 7F"                                                                                  /* APPL... */
};


resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	getFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	50000,
	50000
};

